﻿--
-- Picks up spells from talent frame and puts into Actionbar slot 91-96
-- Provoked when talents are updated
--
function SetTalentActions()
	if MSS_SavedOptions["enable_talentbar"] == 1 then		
		MSS_TalentBar_Mask1:Hide()
		MSS_TalentBar_Mask4:Hide()
		MSS_TalentBar_Mask6:Hide()
		local i
		for i = 1,6 do
			local isFree, index = GetTalentRowSelectionInfo(i)		
			if not isFree then
				local name,icon = GetTalentInfo(index)			
				local mlink, _ = GetSpellLink(name)	
				
				if mlink ~= nil then			
					--print(mlink)
					local _, sid = strsplit(":", strmatch(mlink, "spell:%d+"))			
					--print("In "..name.."="..sid)				
					if not IsPassiveSpell(name) or sid == "106707"--[[faeris sworm]] then
						-- PickupSpell(TALENTS_TABLE[i][name])				
							if sid == "106707" then	--faeris sworm				
								PickupSpell(770)
							elseif sid == "102558" or sid=="102543" or sid == "102560" or sid=="33891"  then  --incarnation
								PickupSpell(106731)
							elseif sid == "33831" or sid=="102703" or sid == "102706" or sid=="102693"  then --trent
								PickupSpell(106737)
							else							
								PickupSpell(tonumber(sid))
							end					
						PlaceAction(90+i)
						ClearCursor()
					else			
						if i == 1 then				
							MSS_TalentBar_Mask1:Show()
						elseif i == 4 then										
							MSS_TalentBar_Mask4:Show()					
						elseif i == 6 then
							MSS_TalentBar_Mask6:Show()
						end			
					end
				end
			else 
				PickupAction(90+i)
				ClearCursor()
			end
		end	
	else		
		MSS_TalentBar:Hide()
		MSS_TalentButton1:Hide()
		MSS_TalentButton2:Hide()
		MSS_TalentButton3:Hide()
		MSS_TalentButton4:Hide()
		MSS_TalentButton5:Hide()			
		MSS_TalentButton6:Hide()	
	end
end


function TimeMaskOnEvent(self, event, ...)			
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	if sourceName == UnitName("player") then
		
		if eventType == "SPELL_CAST_SUCCESS" or eventType == "AURA_APPLIED" then
			local spellId, spellName, spellSchool = select(12, ...)
			local auraType = select(15, ...)			
			--print(eventType.."-"..spellId.."-"..spellName)
			
			if self:GetName() == "MSS_TalentBar_TimeMask3" then
				if spellId == 102355 then --sworm					
					self.count = 15
				elseif spellId == 102359 then --mass tangle
					self.count = 20
				elseif spellId == 132469 then --typhoon
					self.count = 6
				end
			
			elseif self:GetName() == "MSS_TalentBar_TimeMask4" then
				if spellId == 102560 or spellId == 102543 or spellId == 102558 or spellId == 33891 then --incarnation 4 id moonkin cat bear  tree			
					self.count = 30
				elseif spellId == 33831 or spellId == 102703  or spellId == 102706 or spellId == 102693 then --trent 4 id
					self.count = 15
				end			
				
			elseif self:GetName() == "MSS_TalentBar_TimeMask5" then
				if spellId == 99 then --roar					
					self.count = 3
				elseif spellId == 102793 then --vortex
					self.count = 10
				elseif spellId == 5211 then --bash
					self.count = 5
				end				
			end
			
			if self.count ~= 0 then
				if self.text == nil then
					self.text = self:CreateFontString(nil, "OVERLAY", "PVPInfoTextFont")
				end
				self.text:SetAllPoints();
				self.total = 0
				self:SetFrameLevel(100)
				self.text:SetText(self.count)
				self.text:SetTextColor(0,1,0)
				self:Show()
			end
		end
	end
end

function TimeMaskOnUpdate(self, elapsed) 	
	if self.total ~= nil then
		self.total = self.total + elapsed
	
		if self.total >= 1. then
			if self.count ~= nil and self.count > 0 then
				self.count = self.count -1
				self.text:SetText(self.count)
			end
			if self.count == 0 then
				self:Hide()
			end
			self.total = 0
		end
	end
end